PKG_ADD(1)              NetBSD General Commands Manual              PKG_ADD(1)

NNAAMMEE
     ppkkgg__aadddd -- a utility for installing and upgrading software package dis-
     tributions

SSYYNNOOPPSSIISS
     ppkkgg__aadddd [--AAffIILLnnRRUUuuVVvv] [--CC _c_o_n_f_i_g] [--KK _p_k_g___d_b_d_i_r] [--mm _m_a_c_h_i_n_e]
             [--PP _d_e_s_t_d_i_r] [--pp _p_r_e_f_i_x] [--WW _v_i_e_w_b_a_s_e] [--ww _v_i_e_w] _f_i_l_e _._._.
             [[ftp|http]://[_u_s_e_r][:_p_a_s_s_w_o_r_d]@]_h_o_s_t[:_p_o_r_t][/_p_a_t_h_/]_p_k_g_-_n_a_m_e _._._.

DDEESSCCRRIIPPTTIIOONN
     The ppkkgg__aadddd command is used to extract and upgrade packages that have
     been previously created with the pkg_create(1) command.  Packages are
     prepared collections of pre-built binaries, documentation, configura-
     tions, installation instructions and/or other files.  ppkkgg__aadddd can recur-
     sively install other packages that the current package depends on or
     requires from both local disk and via FTP or HTTP.

WWAARRNNIINNGG
     _S_i_n_c_e _t_h_e ppkkgg__aadddd _c_o_m_m_a_n_d _m_a_y _e_x_e_c_u_t_e _s_c_r_i_p_t_s _o_r _p_r_o_g_r_a_m_s _c_o_n_t_a_i_n_e_d
     _w_i_t_h_i_n _a _p_a_c_k_a_g_e _f_i_l_e_, _y_o_u_r _s_y_s_t_e_m _m_a_y _b_e _s_u_s_c_e_p_t_i_b_l_e _t_o _`_`_T_r_o_j_a_n
     _h_o_r_s_e_s_'_' _o_r _o_t_h_e_r _s_u_b_t_l_e _a_t_t_a_c_k_s _f_r_o_m _m_i_s_c_r_e_a_n_t_s _w_h_o _c_r_e_a_t_e _d_a_n_g_e_r_o_u_s
     _p_a_c_k_a_g_e _f_i_l_e_s_.

     _Y_o_u _a_r_e _a_d_v_i_s_e_d _t_o _v_e_r_i_f_y _t_h_e _c_o_m_p_e_t_e_n_c_e _a_n_d _i_d_e_n_t_i_t_y _o_f _t_h_o_s_e _w_h_o _p_r_o_-
     _v_i_d_e _i_n_s_t_a_l_l_a_b_l_e _p_a_c_k_a_g_e _f_i_l_e_s_.  _F_o_r _e_x_t_r_a _p_r_o_t_e_c_t_i_o_n_, _u_s_e _t_h_e _d_i_g_i_t_a_l
     _s_i_g_n_a_t_u_r_e_s _p_r_o_v_i_d_e_d _w_h_e_r_e _p_o_s_s_i_b_l_e _(_s_e_e _t_h_e pkg_install.conf(_5)_)_, _o_r_,
     _f_a_i_l_i_n_g _t_h_a_t_, _u_s_e tar(_1) _t_o _e_x_t_r_a_c_t _t_h_e _p_a_c_k_a_g_e _f_i_l_e_, _a_n_d _i_n_s_p_e_c_t _i_t_s
     _c_o_n_t_e_n_t_s _a_n_d _s_c_r_i_p_t_s _t_o _e_n_s_u_r_e _i_t _p_o_s_e_s _n_o _d_a_n_g_e_r _t_o _y_o_u_r _s_y_s_t_e_m_'_s
     _i_n_t_e_g_r_i_t_y_.  _P_a_y _p_a_r_t_i_c_u_l_a_r _a_t_t_e_n_t_i_o_n _t_o _a_n_y _+_I_N_S_T_A_L_L _o_r _+_D_E_I_N_S_T_A_L_L _f_i_l_e_s_,
     _a_n_d _i_n_s_p_e_c_t _t_h_e _+_C_O_N_T_E_N_T_S _f_i_l_e _f_o_r @@ccwwdd_, @@mmooddee _(_c_h_e_c_k _f_o_r _s_e_t_u_i_d_)_,
     @@ddiirrrrmm_, @@eexxeecc_, _a_n_d @@uunneexxeecc _d_i_r_e_c_t_i_v_e_s_, _a_n_d_/_o_r _u_s_e _t_h_e pkg_info(_1) _c_o_m_m_a_n_d
     _t_o _e_x_a_m_i_n_e _t_h_e _p_a_c_k_a_g_e _f_i_l_e_.

OOPPTTIIOONNSS
     The following command line arguments are supported:

     _p_k_g_-_n_a_m_e [_._._.]
             The named packages are installed.  ppkkgg__aadddd will first try to use
             _p_k_g_-_n_a_m_e as full URL or path name without any wildcard process-
             ing.  If that fails, ppkkgg__aadddd will try to match packages using
             wildcard processing.  If that fails as well and _p_k_g_-_n_a_m_e does not
             contain any /, the entries of the PKG_PATH variable are searched
             using the wildcard processing rules.

     --AA      Mark package as installed automatically, as dependency of another
             package.  You can use
                   ppkkgg__aaddmmiinn sseett aauuttoommaattiicc==YYEESS
             to mark packages this way after installation, and
                   ppkkgg__aaddmmiinn uunnsseett aauuttoommaattiicc
             to remove the mark.  If you ppkkgg__aadddd a package without specifying
             --AA after it had already been automatically installed, the mark is
             removed.

     --CC _c_o_n_f_i_g
             Read the configuration file from _c_o_n_f_i_g instead of the system
             default.

     --ff      Force installation to proceed even if prerequisite packages are
             not installed or the install script fails.  Although ppkkgg__aadddd will
             still try to find and auto-install missing prerequisite packages,
             a failure to find one will not be fatal.  This flag also over-
             rides the fatal error when the operating system or architecture
             the package was built on differ from that of the host.

     --DD      Force updating even if the dependencies of depending packages are
             not satisfied by the new package.  This is used by "make
             replace", after which one would typically replace the depending
             packages.

     --II      If an installation script exists for a given package, do not exe-
             cute it.

     --KK _p_k_g___d_b_d_i_r
             Override the value of the PKG_DBDIR configuration option with the
             value _p_k_g___d_b_d_i_r.

     --LL      Don't add the package to any views after installation.

     --mm      Override the machine architecture returned by uname with _m_a_c_h_i_n_e.

     --nn      Don't actually install a package, just report the steps that
             would be taken if it was.

     --PP _d_e_s_t_d_i_r
             Prefix all file and directory names with _d_e_s_t_d_i_r.  For packages
             without install scripts this has the same behavior as using
             chroot(8).

     --pp _p_r_e_f_i_x
             Override the prefix stored in the package with _p_r_e_f_i_x.

     --RR      Do not record the installation of a package.  This implies --II.
             This means that you cannot deinstall it later, so only use this
             option if you know what you are doing!

     --UU      Replace an already installed version from a package.  Implies --uu.

     --uu      If the package that's being installed is already installed, an
             update is performed.  Installed dependent packages are updated
             recursively, if they are too old to fulfill the dependencies of
             the to-be-installed version.  See below for a more detailed
             description of the process.

     --VV      Print version number and exit.

     --vv      Turn on verbose output.

     --WW _v_i_e_w_b_a_s_e
             Passed down to pkg_view(1) for managed views.

     --ww _v_i_e_w
             Passed down to pkg_view(1) for managed views.

     One or more _p_k_g_-_n_a_m_e arguments may be specified, each being either a file
     containing the package (these usually ending with the ``.tgz'' suffix) or
     a URL pointing at a file available on an ftp or web site.  Thus you may
     extract files directly from their anonymous ftp or WWW locations (e.g.,
     ppkkgg__aadddd ftp://ftp.NetBSD.org/pub/pkgsrc/pack-
     ages/NetBSD/i386/3.1_2007Q2/shells/bash-3.2.9.tgz or ppkkgg__aadddd
     http://www.example.org/packages/screen-4.0.tbz).  Note:  For ftp trans-
     fers, if you wish to use _p_a_s_s_i_v_e _m_o_d_e ftp in such transfers, set the
     variable _F_T_P___P_A_S_S_I_V_E___M_O_D_E to some value in your environment.  Otherwise,
     the more standard ACTIVE mode may be used.  If ppkkgg__aadddd consistently fails
     to fetch a package from a site known to work, it may be because you have
     a firewall that demands the usage of _p_a_s_s_i_v_e _m_o_d_e ftp.

TTEECCHHNNIICCAALL DDEETTAAIILLSS
     ppkkgg__aadddd extracts each package's meta data (including the ``packing
     list'') to memory and then runs through the following sequence to fully
     extract the contents of the package:

           1.   A check is made to determine if the package or another version
                of it is already recorded as installed.  If it is, installa-
                tion is terminated if the --uu or --UU options are not given.

                If the same version is installed and --UU is not given, it is
                marked as manually installed and process stops.  If the --uu
                option is given, it's assumed the package should be replaced
                by the new version instead.  Before doing so, all packages
                that depend on the pkg being upgraded are checked if they also
                work with the new version.  If that test is not successful,
                the dependent packages are updated first.  The replacing is
                then prepared by moving an existing _+_R_E_Q_U_I_R_E_D___B_Y file aside
                (if it exists), and running pkg_delete(1) on the installed
                package.  Installation then proceeds as if the package was not
                installed, and restores the _+_R_E_Q_U_I_R_E_D___B_Y file afterwards.

           2.   The package build information is extracted from the
                _+_B_U_I_L_D___I_N_F_O file and compared against the result of uname(3).
                If the operating system or architecture of the package differ
                from that of the host, installation is aborted.  This behavior
                is overridable with the --ff flag.

           3.   The package build information from _+_B_U_I_L_D___I_N_F_O is then checked
                for USE_ABI_DEPENDS=NO (or IGNORE_RECOMMENDED).  If the pack-
                age was built with ABI dependency recommendations ignored, a
                warning will be issued.

           4.   A check is made to determine if the package conflicts (from
                @@ppkkggccffll directives, see pkg_create(1)) with an already
                recorded as installed package or if an installed package con-
                flicts with the package.  If it is, installation is termi-
                nated.

           5.   The file list of the package is compared to the file lists of
                the installed packages.  If there is any overlap, the instal-
                lation is terminated.

           6.   All package dependencies (from @@ppkkggddeepp directives, see
                pkg_create(1)) are read from the packing list.  If any of
                these required packages are not currently installed, an
                attempt is made to find and install it; if the missing package
                cannot be found or installed, the installation is terminated.

           7.   If the package contains an _i_n_s_t_a_l_l script, it is executed with
                the following arguments:

                _p_k_g_-_n_a_m_e      The name of the package being installed.

                PPRREE--IINNSSTTAALLLL   Keyword denoting that the script is to perform
                              any actions needed before the package is
                              installed.

                If the _i_n_s_t_a_l_l script exits with a non-zero status code, the
                installation is terminated.

           8.   The files from the file list are extracted to the chosen pre-
                fix.

           9.   If an _i_n_s_t_a_l_l script exists for the package, it is executed
                with the following arguments:

                _p_k_g___n_a_m_e      The name of the package being installed.

                PPOOSSTT--IINNSSTTAALLLL  Keyword denoting that the script is to perform
                              any actions needed after the package has been
                              installed.

           10.  After installation is complete, a copy of the packing list,
                _d_e_i_n_s_t_a_l_l script, description, and display files are copied
                into _<_P_K_G___D_B_D_I_R_>_/_<_p_k_g_-_n_a_m_e_> for subsequent possible use by
                pkg_delete(1).  Any package dependencies are recorded in the
                other packages' _+_R_E_Q_U_I_R_E_D___B_Y file.

           11.  If the package is a depoted package, then add it to the regis-
                tered by calling pkg_view(1) accordingly.

           12.  Finally, if we were upgrading a package, any _+_R_E_Q_U_I_R_E_D___B_Y file
                that was moved aside before upgrading was started is now moved
                back into place.

     The _i_n_s_t_a_l_l script is called with the environment variable PKG_PREFIX set
     to the installation prefix (see the --pp option above).  This allows a
     package author to write a script that reliably performs some action on
     the directory where the package is installed, even if the user might
     change it with the --pp flag to ppkkgg__aadddd.  The scripts are also called with
     the PKG_METADATA_DIR environment variable set to the location of the _+_*
     meta-data files, and with the PKG_REFCOUNT_DBDIR environment variable set
     to the location of the package reference counts database directory.  If
     the --PP flag was given to ppkkgg__aadddd, PKG_DESTDIR will be set to _d_e_s_t_d_i_r.
     Additionally, PKG_METADATA_DIR and PKG_REFCOUNT_DBDIR are prefixed with
     _d_e_s_t_d_i_r.

EENNVVIIRROONNMMEENNTT
     See pkg_install.conf(5) for options, that can also be specified using the
     environment.  Packages using views are also affected by the environment
     variables documented for pkg_view(1).

EEXXAAMMPPLLEESS
     In all cases, ppkkgg__aadddd will try to install binary packages listed in
     dependencies list.

     You can specify a compiled binary package explicitly on the command line.

     # pkg_add /usr/pkgsrc/packages/All/tcsh-6.14.00.tgz

     If you omit the version number, ppkkgg__aadddd will install the latest version
     available.  With --vv, ppkkgg__aadddd emits more messages to terminal.

     # pkg_add -v /usr/pkgsrc/packages/All/unzip

     You can grab a compiled binary package from remote location by specifying
     a URL.  The base URL can also be provided by the configuration variable,
     PKG_PATH.

     # pkg_add -v ftp://ftp.NetBSD.org/pub/pkgsrc/packages/NetBSD/i386/3.1_2007Q2/All/firefox-2.0.0.4.tgz

     # export PKG_PATH=ftp://ftp.NetBSD.org/pub/pkgsrc/packages/NetBSD/i386/3.1_2007Q2/All
     # pkg_add -v firefox

SSEEEE AALLSSOO
     pkg_admin(1), pkg_create(1), pkg_delete(1), pkg_info(1),
     pkg_install.conf(5), pkgsrc(7)

AAUUTTHHOORRSS
     Jordan Hubbard
             Initial work and ongoing development.
     John Kohl
             NetBSD refinements.
     Hubert Feyrer
             NetBSD wildcard dependency processing, pkgdb, upgrading, etc.
     Thomas Klausner
             HTTP support.
     Joerg Sonnenberger
             Rewrote most of the code base to work without external commands.

BBUUGGSS
     Package upgrading needs a lot more work to be really universal.

     Sure to be others.

NetBSD 5.0                       June 16, 2010                      NetBSD 5.0
